## docker.io 26.1.5+dfsg1

=== Makefile ===
#
# github.com/docker/cli
#

# Sets the name of the company that produced the windows binary.
PACKAGER_NAME ?=

# The repository doesn't have a go.mod, but "go list", and "gotestsum"
# expect to be run from a module.
GO111MODULE=auto
export GO111MODULE

all: binary

_:=$(shell ./scripts/warn-outside-container $(MAKECMDGOALS))

.PHONY: dev
dev: ## start a build container in interactive mode for in-container development
	@if [ -n "${DISABLE_WARN_OUTSIDE_CONTAINER}" ]; then \
		echo "you are already in the dev container"; \
	else \
		$(MAKE) -f docker.Makefile dev; \
	fi

.PHONY: shell
shell: dev ## alias for dev

.PHONY: clean
clean: ## remove build artifacts
	rm -rf ./build/* man/man[1-9] docs/yaml

.PHONY: test
test: test-unit ## run tests

.PHONY: test-unit
test-unit: ## run unit tests, to change the output format use: GOTESTSUM_FORMAT=(dots|short|standard-quiet|short-verbose|standard-verbose) make test-unit
	gotestsum -- $${TESTDIRS:-$(shell go list ./... | grep -vE '/vendor/|/e2e/')} $(TESTFLAGS)

.PHONY: test-coverage
test-coverage: ## run test coverage
	mkdir -p $(CURDIR)/build/coverage
	gotestsum -- $(shell go list ./... | grep -vE '/vendor/|/e2e/') -coverprofile=$(CURDIR)/build/coverage/coverage.txt

.PHONY: lint
lint: ## run all the lint tools
	golangci-lint run

.PHONY: shellcheck
shellcheck: ## run shellcheck validation
	find scripts/ contrib/completion/bash -type f | grep -v scripts/winresources | grep -v '.*.ps1' | xargs shellcheck

.PHONY: fmt
fmt: ## run gofumpt (if present) or gofmt
	@if command -v gofumpt > /dev/null; then \
		gofumpt -w -d -lang=1.21 . ; \
	else \
		go list -f {{.Dir}} ./... | xargs gofmt -w -s -d ; \
	fi

.PHONY: binary
binary: ## build executable for Linux
	./scripts/build/binary

.PHONY: dynbinary
dynbinary: ## build dynamically linked binary
	GO_LINKMODE=dynamic ./scripts/build/binary

.PHONY: plugins
plugins: ## build example CLI plugins
	./scripts/build/plugins

.PHONY: vendor
vendor: ## update vendor with go modules
	rm -rf vendor
	./scripts/vendor update

.PHONY: validate-vendor
validate-vendor: ## validate vendor
	./scripts/vendor validate

.PHONY: mod-outdated
mod-outdated: ## check outdated dependencies
	./scripts/vendor outdated

.PHONY: authors
authors: ## generate AUTHORS file from git history
	scripts/docs/generate-authors.sh

.PHONY: manpages
manpages: ## generate man pages from go source and markdown
	scripts/docs/generate-man.sh

.PHONY: mddocs
mddocs: ## generate markdown files from go source
	scripts/docs/generate-md.sh

.PHONY: yamldocs
yamldocs: ## generate documentation YAML files consumed by docs repo
	scripts/docs/generate-yaml.sh

.PHONY: help
help: ## print this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {gsub("\\\\n",sprintf("\n%22c",""), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

=== debian/changelog ===
docker.io (26.1.5+dfsg1-9ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/tests/control: remove since all tests are related to the docker application
      provided by docker.io binary package.
    - d/golang-github-docker-docker-dev.docs: install NOTICE files to comply
      with Apache license.
    - d/control: add non default pkg.docker.with-bin Build-Profiles
      to disable building docker.io, docker-cli, and docker.io-doc binary package
      by default.
      And change Architecture to amd64 to avoid Launchpad reporting build
      failures on other architecture.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 22 Feb 2025 09:30:12 +0100

docker.io (26.1.5+dfsg1-9) unstable; urgency=medium

  * Add buildx to Recommends of cli (Closes: #1087370)

 -- Tianon Gravi <tianon@debian.org>  Fri, 21 Feb 2025 11:17:16 -0800

docker.io (26.1.5+dfsg1-8) unstable; urgency=medium

  * Fix netlink via moby/moby#48368 + moby/moby#48407 (Closes: #1092165)
  * Update "basic-smoke" test to validate #1092165 fix
  * Update "basic-smoke" test to use bookworm (instead of bullseye)

 -- Tianon Gravi <tianon@debian.org>  Thu, 20 Feb 2025 14:27:26 -0800

docker.io (26.1.5+dfsg1-7ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/tests/control: remove since all tests are related to the docker application
      provided by docker.io binary package.
    - d/golang-github-docker-docker-dev.docs: install NOTICE files to comply
      with Apache license.
    - d/control: add non default pkg.docker.with-bin Build-Profiles
      to disable building docker.io, docker-cli, and docker.io-doc binary package
      by default.
      And change Architecture to amd64 to avoid Launchpad reporting build
      failures on other architecture.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2025 15:38:02 +0100

docker.io (26.1.5+dfsg1-7) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 16 Feb 2025 15:27:11 -0500

docker.io (26.1.5+dfsg1-6) experimental; urgency=medium

  [ Nicolas Peugnet ]
  * Add more docker/cli packages to golang-github-docker-docker-dev
  * Add the importpaths of other modules present in golang-github-docker-docker-dev
  * Selectively install packages from buildkit

  [ Reinhard Tartler ]
  * Package buildkit as extra component in the upstream tarball
  * buildkit: avoid hcsshim, jaeger dependencies

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 10 Feb 2025 10:27:05 -0500

docker.io (26.1.5+dfsg1-5) experimental; urgency=medium

  [ Nicolas Peugnet ]
  * Fix location of libnetwork in golang-github-docker-docker-dev
  * Add github.com/docker/cli/cli/connhelper to golang-github-docker-docker-dev

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 01 Feb 2025 12:06:39 -0500

docker.io (26.1.5+dfsg1-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/tests/control: remove since all tests are related to the docker application
      provided by docker.io binary package.
    - d/golang-github-docker-docker-dev.docs: install NOTICE files to comply
      with Apache license.
    - d/control: add non default pkg.docker.with-bin Build-Profiles
      to disable building docker.io, docker-cli, and docker.io-doc binary package
      by default.
      And change Architecture to amd64 to avoid Launchpad reporting build
      failures on other architecture.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Nov 2024 23:22:30 +0100

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Standards-Version: 4.7.0
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Arnaud Rebillout <arnaudr@kali.org>
          ,Dmitry Smirnov <onlyjob@debian.org>
          ,Tim Potter <tpot@hpe.com>
          ,Tianon Gravi <tianon@debian.org>
          ,Paul Tagliamonte <paultag@debian.org>
          ,Reinhard Tartler <siretart@tauware.de>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: debhelper-compat (= 13) ,dh-apparmor ,dh-golang (>= 1.14~)
    ,bash-completion
    ,ca-certificates
    ,golang-any (>= 2:1.10~)
    ,go-md2man (>= 1.0.3~)
    ,golang-dbus-dev (>= 5.0.2~)
#    ,golang-etcd-server-dev
    ,golang-github-adamkorcz-go-fuzz-headers-1-dev
    ,golang-github-agext-levenshtein-dev
    ,golang-github-armon-circbuf-dev
    ,golang-github-armon-go-metrics-dev
    ,golang-github-aws-aws-sdk-go-v2-dev
    ,golang-github-aws-smithy-go-dev
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-bsphere-le-go-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-cespare-xxhash-dev
    ,golang-github-cenkalti-backoff-dev
    ,golang-github-cilium-ebpf-dev
    ,golang-github-cloudflare-cfssl-dev (>= 1.6.4)
    ,golang-github-containerd-console-dev
    ,golang-github-containerd-containerd-dev (>= 1.7.23~)
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-containerd-fifo-dev (>= 1.1.0~)
    ,golang-github-containerd-go-cni-dev
    ,golang-github-containerd-go-runc-dev (>= 1.1.0)
    ,golang-github-containerd-typeurl-dev (>= 2.1.1-2)
    ,golang-github-containernetworking-plugins-dev
    ,golang-github-coreos-bbolt-dev (>= 1.3.10)
    ,golang-github-coreos-go-systemd-dev (>= 20~)
    ,golang-github-creack-pty-dev
    ,golang-github-cyphar-filepath-securejoin-dev
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-deckarep-golang-set-dev (>= 2.3.0~)
    ,golang-github-dimchansky-utfbom-dev
    ,golang-github-distribution-reference-dev
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-events-dev
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-libtrust-dev
    ,golang-github-docker-notary-dev (>= 0.7.0+git20240416)
    ,golang-github-felixge-httpsnoop-dev
    ,golang-github-fernet-fernet-go-dev
    ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-fvbommel-sortorder-dev
    ,golang-github-go-logr-logr-dev
    ,golang-github-go-logr-stdr-dev
    ,golang-github-gofrs-flock-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-golang-groupcache-dev
    ,golang-github-golang-jwt-jwt-dev    
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-google-go-cmp-dev (>= 0.2.0~)
    ,golang-github-google-shlex-dev
    ,golang-github-google-uuid-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-gotestyourself-gotest.tools-dev
    ,golang-github-graylog2-go-gelf-dev (>= 0.0+git20191017~)
    ,golang-github-grpc-ecosystem-go-grpc-prometheus-dev
    ,golang-github-grpc-ecosystem-grpc-opentracing-dev
    ,golang-github-hashicorp-go-memdb-dev
    ,golang-github-hashicorp-go-immutable-radix-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-imdario-mergo-dev (>= 0.3.3~)
    ,golang-github-in-toto-in-toto-golang-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-json-iterator-go-dev (>= 1.1.4~)
    ,golang-github-klauspost-compress-dev
    ,golang-github-mattn-go-runewidth-dev
    ,golang-github-miekg-dns-dev (>= 1.1.26~)
    ,golang-github-mitchellh-hashstructure-dev (>= 2.0.2)
    ,golang-github-moby-docker-image-spec-dev
    ,golang-github-moby-locker-dev
    ,golang-github-moby-patternmatcher-dev
    ,golang-github-moby-pubsub-dev
    ,golang-github-moby-sys-dev
    ,golang-github-moby-term-dev
    ,golang-github-modern-go-reflect2-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-nxadm-tail-dev
    ,golang-github-onsi-ginkgo-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
    ,golang-github-opentracing-contrib-go-stdlib-dev
    ,golang-github-opentracing-opentracing-go-dev (>= 0.0~git20180507)
    ,golang-opentelemetry-contrib-dev (>= 0.56)
    ,golang-opentelemetry-otel-dev (>= 1.31)
    ,golang-opentelemetry-proto-dev (>= 1.3.1)
    ,golang-github-pelletier-go-toml-dev
    ,golang-github-philhofer-fwd-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-racksec-srslog-dev
    ,golang-github-rcrowley-go-metrics-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-spf13-cobra-dev (>= 1.1.1~)
    ,golang-github-spf13-pflag-dev (>= 1.0.5-2~)
    ,golang-github-stretchr-testify-dev
    ,golang-github-tchap-go-patricia-dev
#    ,golang-github-tonistiigi-fsutil-dev (>= 0.0~git20200724~)
    ,golang-github-tonistiigi-units-dev
    ,golang-github-rootless-containers-rootlesskit-dev (>= 2)
    ,golang-github-secure-systems-lab-go-securesystemslib-dev
    ,golang-github-urfave-cli-dev (>= 1.20.0~)
    ,golang-github-vbatts-tar-split-dev (>= 0.11.1~)
    ,golang-github-xeipuuv-gojsonschema-dev (>= 1.2.0~)
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-google-dev | golang-golang-x-oauth2-dev
    ,golang-golang-x-term-dev
    ,golang-golang-x-time-dev
    ,golang-google-api-dev
    ,golang-google-cloud-dev
    ,golang-google-grpc-dev (>> 1.64)
    ,golang-github-golang-protobuf-1-5-dev
    ,golang-go-zfs-dev
    ,golang-protobuf-extensions-dev
    ,golang-k8s-klog-dev
    ,gotestsum
    ,libapparmor-dev
    ,libseccomp-dev
    ,libsystemd-dev
    ,pkgconf
    ,procps
    ,tzdata
# tests:
    ,git
    ,golang-github-adalogics-go-fuzz-headers-dev
Homepage: https://mobyproject.org
Vcs-Browser: https://salsa.debian.org/go-team/packages/docker
Vcs-Git: https://salsa.debian.org/go-team/packages/docker.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/docker/docker
    ,github.com/docker/cli
    ,github.com/moby/buildkit
    ,github.com/moby/ipvs

Package: docker.io
Build-Profiles: <pkg.docker.with-bin>
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends} ,${shlibs:Depends}
    ,adduser
    ,containerd (>= 1.4~)
    ,iptables
    ,sysvinit-utils (>= 3.05-4~)
    ,runc (>= 1.0.0~rc8~)
    ,tini
Recommends: apparmor
    ,ca-certificates
    ,dbus-user-session
    ,docker-cli
    ,git
    ,needrestart (>= 3.1~)
    ,xz-utils
Conflicts:
## Docker's vendor packages:
    docker-ce
    ,docker-ce-rootless-extras
Suggests: docker-doc
    ,aufs-tools
    ,btrfs-progs
    ,cgroupfs-mount
    ,debootstrap
    ,e2fsprogs
    ,rinse
    ,rootlesskit
    ,xfsprogs
    ,zfs-fuse | zfsutils-linux
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon only. For the command-line utility
 "/usr/bin/docker", please install the "docker-cli" package.
 .
 Using docker.io on non-amd64 hosts is not supported at this time. Please be
 careful when using it on anything besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: docker-cli
Build-Profiles: <pkg.docker.with-bin>
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends} ,${shlibs:Depends}
Conflicts:
## Docker's (old) vendor package:
    docker-ce-cli
## podman-docker is providing an alternative docker implementation
    ,podman-docker
# the version of "docker.io" prior to the introduction of the separate "docker-cli" package
Replaces: docker.io (<< 26.1.4+dfsg1-7~)
Breaks: docker.io (<< 26.1.4+dfsg1-7~)
Recommends: docker-buildx
Suggests: docker-doc
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime -- client
 This package contains the "docker" client binary for interacting with a running
 Docker daemon.
 .
 See the "docker.io" package for the full Docker daemon experience.

Package: golang-github-docker-docker-dev
Architecture: all
Section: golang
Depends: ${misc:Depends}
    ,golang-github-armon-circbuf-dev
    ,golang-github-cloudflare-cfssl-dev (>= 1.6.4)
    ,golang-github-containerd-containerd-dev (>= 1.7.23~)
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-containerd-typeurl-dev (>= 2.1.1-2)
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-notary-dev (>= 0.7.0+git20240416)
    ,golang-github-distribution-reference-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-fvbommel-sortorder-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-in-toto-in-toto-golang-dev
    ,golang-github-mitchellh-hashstructure-dev (>= 2.0.2)
    ,golang-github-moby-docker-image-spec-dev
    ,golang-github-moby-locker-dev
    ,golang-github-moby-patternmatcher-dev
    ,golang-github-moby-pubsub-dev
    ,golang-github-moby-sys-dev
    ,golang-github-moby-term-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-spf13-cobra-dev (>= 1.1.1~)
    ,golang-github-tchap-go-patricia-dev
    ,golang-github-tonistiigi-fsutil-dev
    ,golang-github-tonistiigi-units-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev (>= 0.0~git20190726~)
    ,golang-opentelemetry-contrib-dev (>= 0.42)
    ,golang-opentelemetry-otel-dev (>= 1.21)
# libnetwork:
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-go-events-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev
Description: reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: docker-doc
Build-Profiles: <pkg.docker.with-bin>
Provides: docker.io-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# The engine is built and tested using upstream scripts
# and Makefiles, rather than dh_auto_*. Therefore we can't rely
# on dh to set the environment for us, we have to do it here.
export GOPATH := $(CURDIR)/_build
export GOCACHE := $(GOPATH)/go-build
export GO111MODULE := off
export GOPROXY := off

#export DH_GOLANG_BUILDPKG := github.com/docker/docker github.com/docker/cli
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA := testdata/
export DH_GOLANG_EXCLUDES := \
    integration-cli \
    overlay_test \
    vendor

# Package names
CLI_PKG        := github.com/docker/cli
ENGINE_PKG     := github.com/docker/docker
BUILDKIT_PKG   := github.com/moby/buildkit

# Version and commits
DOCKER_VERSION := $(DEB_VERSION_UPSTREAM)
ENGINE_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh engine $(DOCKER_VERSION))
ifndef ENGINE_GITCOMMIT
  $(error Missing ENGINE_GITCOMMIT - see debian/helpers/engine-gitcommits)
endif
CLI_GITCOMMIT    := $(shell ./debian/helpers/gitcommit.sh cli $(DOCKER_VERSION))
ifndef CLI_GITCOMMIT
  $(error Missing CLI_GITCOMMIT - see debian/helpers/cli-gitcommits)
endif

# Cf. scripts/build/binary scripts/build/.variables
CLI_BUILDTIME := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" +"%Y-%m-%dT%H:%M:%SZ")
CLI_BUILDTAGS := pkcs11
CLI_LDFLAGS   += -X $(CLI_PKG)/cli/version.BuildTime=$(CLI_BUILDTIME)
CLI_LDFLAGS   += -X $(CLI_PKG)/cli/version.GitCommit=$(CLI_GITCOMMIT)
CLI_LDFLAGS   += -X $(CLI_PKG)/cli/version.Version=$(DOCKER_VERSION)
ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el))
CLI_BUILDMODE := -buildmode=pie
endif

# Cf. hack/make.sh hack/make/.binary
ENGINE_BUILDTIME := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" --rfc-3339 ns | sed -e 's/ /T/')
ENGINE_BUILDTAGS := apparmor seccomp journald
ENGINE_TESTFLAGS := -test.short
ENGINE_LDFLAGS   := -w
ENGINE_LDFLAGS   += -X $(ENGINE_PKG)/dockerversion.Version=$(DOCKER_VERSION)
ENGINE_LDFLAGS   += -X $(ENGINE_PKG)/dockerversion.GitCommit=$(ENGINE_GITCOMMIT)
ENGINE_LDFLAGS   += -X $(ENGINE_PKG)/dockerversion.BuildTime=$(ENGINE_BUILDTIME)
ENGINE_LDFLAGS   += -X $(ENGINE_PKG)/dockerversion.PlatformName=
ENGINE_LDFLAGS   += -X $(ENGINE_PKG)/dockerversion.ProductName=docker
ENGINE_LDFLAGS   += -X $(ENGINE_PKG)/dockerversion.DefaultProductLicense=

ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el))
ENGINE_BUILDMODE := -buildmode=pie
endif

BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

%:
	dh $@ --buildsystem=golang --with=bash-completion,golang --builddirectory=_build

override_dh_golang:
## Set DH_GOLANG_BUILDPKG so that Built-Using is properly generated.
	DH_GOLANG_BUILDPKG="$(CLI_PKG)/... $(ENGINE_PKG)/... $(BUILDKIT_PKG)/..." \
	  dh_golang -O--buildsystem=golang -O--builddirectory=_build

override_dh_clean:
	dh_clean
	$(RM) -v -r autogen bundles man/man*/ debian/tmphome
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say grep { $$_=q{ */}.$$_ } split(/\s+/,$$1) if m{^Files\-Excluded:\s*(.*?)(?:\n\n|^Files|^Comment:)}sm;' debian/copyright`
	-find */vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
## dh_auto_configure symlinks dirs from "/usr/share/gocode/src" into
## $(GOPATH) unless folders already exist there in which case files
## are copied. Pre-making directories allows us to use debhelper to
## create proper GOPATH source tree yet have certain directories writable
## even if they are provided by already installed package.
	mkdir -pv $(GOPATH)/src/$(CLI_PKG)
	mkdir -pv $(GOPATH)/src/$(ENGINE_PKG)
	mkdir -pv $(GOPATH)/src/$(BUILDKIT_PKG)

## Prepare builddirectory but throw away sourcedirectory.
	DH_GOPKG="__IGNORE__" dh_auto_configure

## Each package must be removed from working tree first, in case some
## of the packages that we are going to build are already installed.
## This is also useful for building in unclean environment.
##
## This is _necessary_ to avoid merging packages that we build with
## pre-installed packages. See #827226 for details.
## Debhelper knows only about "main" DH_GOPKG package but we build several
## and we have to ensure that build tree is properly prepared.
	$(RM) -r              $(GOPATH)/src/$(CLI_PKG)
	cp -ra  cli           $(GOPATH)/src/$(CLI_PKG)
	$(RM) -r              $(GOPATH)/src/$(ENGINE_PKG)
	cp -ra  engine        $(GOPATH)/src/$(ENGINE_PKG)
	$(RM) -r              $(GOPATH)/src/$(BUILDKIT_PKG)
	cp -ra  buildkit      $(GOPATH)/src/$(BUILDKIT_PKG)

override_dh_auto_build:
## Order is important:

	# enable when we start additional binaries, such as buildkitd, etc.
	# GENERATE=0 avoid protoc and gogoprotobuf dependencies
	#DH_GOPKG=$(BUILDKIT_PKG) DH_GOLANG_GO_GENERATE=0 dh_auto_build -v

	DH_GOPKG=$(ENGINE_PKG) DH_GOLANG_BUILDPKG=$(ENGINE_PKG)/cmd/dockerd \
	  dh_auto_build -v -- -tags '$(ENGINE_BUILDTAGS)' $(ENGINE_BUILDMODE) -ldflags '$(ENGINE_LDFLAGS)'

	DH_GOPKG=$(ENGINE_PKG) DH_GOLANG_BUILDPKG=$(ENGINE_PKG)/cmd/docker-proxy \
	  dh_auto_build -v -- -tags '$(ENGINE_BUILDTAGS)' $(ENGINE_BUILDMODE) -ldflags '$(ENGINE_LDFLAGS)'

	DH_GOPKG=$(CLI_PKG) DH_GOLANG_BUILDPKG=$(CLI_PKG)/cmd/docker \
	  dh_auto_build -v -- -tags '$(CLI_BUILDTAGS)' -ldflags '$(CLI_LDFLAGS)' $(CLI_BUILDMODE)
	cd $(GOPATH)/src/$(CLI_PKG) && ./scripts/docs/generate-man.sh

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# basic smoke test -- these must pass
	_build/bin/docker --version
	_build/bin/dockerd --version

	## Test engine:
	-cd $(GOPATH)/src/$(ENGINE_PKG) && PATH=$(GOPATH)/bin:$(PATH) TESTFLAGS='$(ENGINE_TESTFLAGS)' ./hack/test/unit

	# Unit tests -- these are notoriously flaky and not written with the intend
	# to be run outside of a tightly controlled container image. Therefore,
	# ignore failures
	## Test CLI:
	mkdir -p $(CURDIR)/debian/tmphome/tmp
	-cd $(GOPATH)/src/$(CLI_PKG) && HOME=$(CURDIR)/debian/tmphome TMPDIR=$(CURDIR)/debian/tmphome/tmp PATH=$(GOPATH)/bin:$(PATH) DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit GO111MODULE=off
endif

override_dh_install:
	## Do not install extra license files:
	dh_install -XLICENSE
	## Apparmor thing, not sure it's needed, we don't install a profile
	dh_apparmor --profile-name=docker.io -pdocker.io

override_dh_auto_install:
	## skip dh_auto_install to stop dh_golang trying to copy bits
	## for /usr/share/gocode (we use dh_install for that)

override_dh_installinit:
	dh_installinit -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev -v --name=docker --priority=z80

override_dh_gencontrol:
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol

## docker.io 27.5.1%2Bdfsg3

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: docker.io
 Section: admin
 Priority: optional
-Standards-Version: 4.7.0
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Standards-Version: 4.7.2
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Arnaud Rebillout <arnaudr@kali.org>
           ,Dmitry Smirnov <onlyjob@debian.org>
           ,Tim Potter <tpot@hpe.com>
@@ -17,7 +16,7 @@
     ,golang-any (>= 2:1.10~)
     ,go-md2man (>= 1.0.3~)
     ,golang-dbus-dev (>= 5.0.2~)
-#    ,golang-etcd-server-dev
+    ,golang-etcd-server-dev
     ,golang-github-adamkorcz-go-fuzz-headers-1-dev
     ,golang-github-agext-levenshtein-dev
     ,golang-github-armon-circbuf-dev
@@ -25,6 +24,7 @@
     ,golang-github-aws-aws-sdk-go-v2-dev
     ,golang-github-aws-smithy-go-dev
     ,golang-github-azure-go-ansiterm-dev
+    ,golang-github-bits-and-blooms-bitset-dev
     ,golang-github-bsphere-le-go-dev
     ,golang-github-burntsushi-toml-dev
     ,golang-github-cespare-xxhash-dev
@@ -55,7 +55,6 @@
     ,golang-github-docker-go-units-dev (>= 0.4.0~)
     ,golang-github-docker-libkv-dev
     ,golang-github-docker-libtrust-dev
-    ,golang-github-docker-notary-dev (>= 0.7.0+git20240416)
     ,golang-github-felixge-httpsnoop-dev
     ,golang-github-fernet-fernet-go-dev
     ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
@@ -63,10 +62,11 @@
     ,golang-github-fvbommel-sortorder-dev
     ,golang-github-go-logr-logr-dev
     ,golang-github-go-logr-stdr-dev
+    ,golang-github-go-viper-mapstructure-dev (>> 2.2.1-1)
     ,golang-github-gofrs-flock-dev
     ,golang-github-gogo-googleapis-dev
     ,golang-github-golang-groupcache-dev
-    ,golang-github-golang-jwt-jwt-dev    
+    ,golang-github-golang-jwt-jwt-v5-dev
     ,golang-github-googleapis-gax-go-dev
     ,golang-github-google-go-cmp-dev (>= 0.2.0~)
     ,golang-github-google-shlex-dev
@@ -92,15 +92,15 @@
     ,golang-github-moby-locker-dev
     ,golang-github-moby-patternmatcher-dev
     ,golang-github-moby-pubsub-dev
-    ,golang-github-moby-sys-dev
+    ,golang-github-moby-sys-dev (>> 0.0~git20250819.9dc3a90)
     ,golang-github-moby-term-dev
     ,golang-github-modern-go-reflect2-dev
     ,golang-github-morikuni-aec-dev
     ,golang-github-nxadm-tail-dev
     ,golang-github-onsi-ginkgo-dev
+    ,golang-github-opencontainers-cgroups-dev (>= 0.0.1~)
     ,golang-github-opencontainers-go-digest-dev
     ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
-    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
     ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
     ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
     ,golang-github-opentracing-contrib-go-stdlib-dev
@@ -121,6 +121,7 @@
     ,golang-github-tchap-go-patricia-dev
 #    ,golang-github-tonistiigi-fsutil-dev (>= 0.0~git20200724~)
     ,golang-github-tonistiigi-units-dev
+    ,golang-github-tonistiigi-vt100-dev
     ,golang-github-rootless-containers-rootlesskit-dev (>= 2)
     ,golang-github-secure-systems-lab-go-securesystemslib-dev
     ,golang-github-urfave-cli-dev (>= 1.20.0~)
@@ -131,12 +132,13 @@
     ,golang-golang-x-term-dev
     ,golang-golang-x-time-dev
     ,golang-google-api-dev
+    ,golang-github-golang-protobuf-1-5-dev
     ,golang-google-cloud-dev
-    ,golang-google-grpc-dev (>> 1.64)
-    ,golang-github-golang-protobuf-1-5-dev
+    ,golang-google-grpc-dev (>> 1.66.3)
     ,golang-go-zfs-dev
     ,golang-protobuf-extensions-dev
     ,golang-k8s-klog-dev
+    ,golang-k8s-sigs-yaml-dev
     ,gotestsum
     ,libapparmor-dev
     ,libseccomp-dev
@@ -157,8 +159,7 @@
     ,github.com/moby/ipvs
 
 Package: docker.io
-Build-Profiles: <pkg.docker.with-bin>
-Architecture: amd64
+Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends} ,${shlibs:Depends}
     ,adduser
@@ -179,16 +180,14 @@
     docker-ce
     ,docker-ce-rootless-extras
 Suggests: docker-doc
-    ,aufs-tools
     ,btrfs-progs
-    ,cgroupfs-mount
     ,debootstrap
     ,e2fsprogs
     ,rinse
     ,rootlesskit
     ,xfsprogs
     ,zfs-fuse | zfsutils-linux
-Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Description: Linux container runtime
  Docker complements kernel namespacing with a high-level API which operates at
  the process level. It runs unix processes with strong guarantees of isolation
@@ -201,16 +200,17 @@
  This package contains the daemon only. For the command-line utility
  "/usr/bin/docker", please install the "docker-cli" package.
  .
- Using docker.io on non-amd64 hosts is not supported at this time. Please be
- careful when using it on anything besides amd64.
- .
- Also, note that kernel version 3.8 or above is required for proper operation of
- the daemon process, and that any lower versions may have subtle and/or glaring
- issues.
+ WARNING: Installation starts the daemon immediately and adds iptables rules
+ for container networking. These may disrupt existing firewall setups or VM
+ networking, potentially breaking connectivity. Test on non-critical systems
+ first. To disable: set DOCKER_OPTS="--iptables=false" in /etc/default/docker
+ before install. Also, the default configuration will create a "docker0" bridge
+ interface for container networking. To configure this behavior, please check
+ the documentation on the "--bip" and "-b" command-line arguments in
+ dockerd(8).
 
 Package: docker-cli
-Build-Profiles: <pkg.docker.with-bin>
-Architecture: amd64
+Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends} ,${shlibs:Depends}
 Conflicts:
@@ -219,11 +219,11 @@
 ## podman-docker is providing an alternative docker implementation
     ,podman-docker
 # the version of "docker.io" prior to the introduction of the separate "docker-cli" package
-Replaces: docker.io (<< 26.1.4+dfsg1-7~)
-Breaks: docker.io (<< 26.1.4+dfsg1-7~)
+Replaces: docker.io (<< 27.5.1)
+Breaks: docker.io (<< 27.5.1)
 Recommends: docker-buildx
 Suggests: docker-doc
-Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Description: Linux container runtime -- client
  This package contains the "docker" client binary for interacting with a running
  Docker daemon.
@@ -238,6 +238,7 @@
     ,golang-github-cloudflare-cfssl-dev (>= 1.6.4)
     ,golang-github-containerd-containerd-dev (>= 1.7.23~)
     ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
+    ,golang-github-containerd-platforms-dev
     ,golang-github-containerd-typeurl-dev (>= 2.1.1-2)
     ,golang-github-docker-distribution-dev (>= 2.7.1~)
     ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
@@ -245,11 +246,11 @@
     ,golang-github-docker-go-metrics-dev
     ,golang-github-docker-go-units-dev (>= 0.4.0~)
     ,golang-github-docker-libkv-dev
-    ,golang-github-docker-notary-dev (>= 0.7.0+git20240416)
     ,golang-github-distribution-reference-dev
     ,golang-github-fsnotify-fsnotify-dev
     ,golang-github-fvbommel-sortorder-dev
-    ,golang-github-gogo-googleapis-dev
+    ,golang-github-go-viper-mapstructure-dev (>> 2.2.1-1)
+##    ,golang-github-gogo-googleapis-dev # not needed?
     ,golang-github-gorilla-mux-dev (>= 1.7.1~)
     ,golang-github-in-toto-in-toto-golang-dev
     ,golang-github-mitchellh-hashstructure-dev (>= 2.0.2)
@@ -257,7 +258,7 @@
     ,golang-github-moby-locker-dev
     ,golang-github-moby-patternmatcher-dev
     ,golang-github-moby-pubsub-dev
-    ,golang-github-moby-sys-dev
+    ,golang-github-moby-sys-dev (>> 0.0~git20250819.9dc3a90)
     ,golang-github-moby-term-dev
     ,golang-github-morikuni-aec-dev
     ,golang-github-opencontainers-go-digest-dev
@@ -269,6 +270,7 @@
     ,golang-github-tchap-go-patricia-dev
     ,golang-github-tonistiigi-fsutil-dev
     ,golang-github-tonistiigi-units-dev
+    ,golang-github-tonistiigi-vt100-dev
     ,golang-golang-x-net-dev
     ,golang-golang-x-sys-dev (>= 0.0~git20190726~)
     ,golang-opentelemetry-contrib-dev (>= 0.42)
@@ -282,20 +284,13 @@
     ,golang-github-ishidawataru-sctp-dev
     ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
     ,golang-github-vishvananda-netns-dev
-Description: reusable Go packages included with Docker
- These packages are intentionally developed by upstream in such a way that they
- are reusable to projects outside Docker and only rely on each other or other
- external dependencies to be built.
-
-Package: docker-doc
-Build-Profiles: <pkg.docker.with-bin>
-Provides: docker.io-doc
-Section: doc
-Architecture: all
-Multi-Arch: foreign
-Depends: ${misc:Depends}
-Description: Linux container runtime -- documentation
- Docker complements kernel namespacing with a high-level API which operates at
- the process level. It runs unix processes with strong guarantees of isolation
- and repeatability across servers.
- .
+Breaks:
+    ,crowdsec (<< 1.4.6-10.1)
+    ,docker-compose (<< 2.32)
+    ,golang-github-docker-buildx-dev (<< 0.19)
+    ,golang-github-containers-buildah-dev (<< 1.41.5+ds1-2)
+    ,golang-github-openshift-imagebuilder-dev (<< 1.2.15+ds1-3)
+Conflicts:
+    golang-github-docker-notary-dev
+Replaces:
+    golang-github-docker-notary-dev

## docker.io 27.5.1+dfsg1

=== Makefile ===
prefix=/usr/local
bindir=$(prefix)/bin

ifneq (, $(BUILDX_BIN))
	export BUILDX_CMD = $(BUILDX_BIN)
else ifneq (, $(shell docker buildx version))
	export BUILDX_CMD = docker buildx
else ifneq (, $(shell command -v buildx))
	export BUILDX_CMD = $(command -v buildx)
endif

export BUILDX_CMD ?= docker buildx

.PHONY: binaries
binaries:
	$(BUILDX_CMD) bake binaries

.PHONY: cross
cross:
	$(BUILDX_CMD) bake binaries-cross

.PHONY: images
images:
# moby/buildkit:local and moby/buildkit:local-rootless are created on Docker
	hack/images local moby/buildkit
	TARGET=rootless hack/images local moby/buildkit

.PHONY: install
install:
	mkdir -p $(DESTDIR)$(bindir)
	install bin/build/* $(DESTDIR)$(bindir)

.PHONY: release
release:
	./hack/release

.PHONY: clean
clean:
	rm -rf ./bin

.PHONY: test
test:
	./hack/test integration gateway dockerfile

.PHONY: test-race
test-race:
	CGO_ENABLED=1 GOBUILDFLAGS="-race" ./hack/test integration gateway dockerfile

.PHONY: lint
lint:
	$(BUILDX_CMD) bake lint

.PHONY: validate-vendor
validate-vendor:
	$(BUILDX_CMD) bake validate-vendor

.PHONY: validate-shfmt
validate-shfmt:
	$(BUILDX_CMD) bake validate-shfmt

.PHONY: shfmt
shfmt:
	$(BUILDX_CMD) bake shfmt

.PHONY: validate-authors
validate-authors:
	$(BUILDX_CMD) bake validate-authors

.PHONY: validate-generated-files
validate-generated-files:
	$(BUILDX_CMD) bake validate-generated-files

.PHONY: validate-archutil
validate-archutil:
	$(BUILDX_CMD) bake validate-archutil

.PHONY: validate-doctoc
validate-doctoc:
	$(BUILDX_CMD) bake validate-doctoc

.PHONY: validate-docs
validate-docs:
	$(BUILDX_CMD) bake validate-docs

.PHONY: validate-all
validate-all: test lint validate-vendor validate-generated-files validate-archutil validate-doctoc validate-docs

.PHONY: vendor
vendor:
	$(eval $@_TMP_OUT := $(shell mktemp -d -t buildkit-output.XXXXXXXXXX))
	$(BUILDX_CMD) bake --set "*.output=type=local,dest=$($@_TMP_OUT)" vendor
	rm -rf ./vendor
	cp -R "$($@_TMP_OUT)"/out/* .
	rm -rf "$($@_TMP_OUT)"/

.PHONY: generated-files
generated-files:
	$(BUILDX_CMD) bake generated-files

.PHONY: archutil
archutil:
	$(BUILDX_CMD) bake archutil

.PHONY: authors
authors:
	$(BUILDX_CMD) bake authors

.PHONY: doctoc
doctoc:
	$(BUILDX_CMD) bake doctoc

.PHONY: docs
docs:
	$(BUILDX_CMD) bake docs

.PHONY: docs-dockerfile
docs-dockerfile:
	$(BUILDX_CMD) bake docs-dockerfile

.PHONY: mod-outdated
mod-outdated:
	$(BUILDX_CMD) bake mod-outdated

=== engine/vendor/go.uber.org/atomic/Makefile ===
# Directory to place `go install`ed binaries into.
export GOBIN ?= $(shell pwd)/bin

GOLINT = $(GOBIN)/golint
GEN_ATOMICINT = $(GOBIN)/gen-atomicint
GEN_ATOMICWRAPPER = $(GOBIN)/gen-atomicwrapper
STATICCHECK = $(GOBIN)/staticcheck

GO_FILES ?= $(shell find . '(' -path .git -o -path vendor ')' -prune -o -name '*.go' -print)

# Also update ignore section in .codecov.yml.
COVER_IGNORE_PKGS = \
	go.uber.org/atomic/internal/gen-atomicint \
	go.uber.org/atomic/internal/gen-atomicwrapper

.PHONY: build
build:
	go build ./...

.PHONY: test
test:
	go test -race ./...

.PHONY: gofmt
gofmt:
	$(eval FMT_LOG := $(shell mktemp -t gofmt.XXXXX))
	gofmt -e -s -l $(GO_FILES) > $(FMT_LOG) || true
	@[ ! -s "$(FMT_LOG)" ] || (echo "gofmt failed:" && cat $(FMT_LOG) && false)

$(GOLINT):
	cd tools && go install golang.org/x/lint/golint

$(STATICCHECK):
	cd tools && go install honnef.co/go/tools/cmd/staticcheck

$(GEN_ATOMICWRAPPER): $(wildcard ./internal/gen-atomicwrapper/*)
	go build -o $@ ./internal/gen-atomicwrapper

$(GEN_ATOMICINT): $(wildcard ./internal/gen-atomicint/*)
	go build -o $@ ./internal/gen-atomicint

.PHONY: golint
golint: $(GOLINT)
	$(GOLINT) ./...

.PHONY: staticcheck
staticcheck: $(STATICCHECK)
	$(STATICCHECK) ./...

.PHONY: lint
lint: gofmt golint staticcheck generatenodirty

# comma separated list of packages to consider for code coverage.
COVER_PKG = $(shell \
	go list -find ./... | \
	grep -v $(foreach pkg,$(COVER_IGNORE_PKGS),-e "^$(pkg)$$") | \
	paste -sd, -)

.PHONY: cover
cover:
	go test -coverprofile=cover.out -coverpkg  $(COVER_PKG) -v ./...
	go tool cover -html=cover.out -o cover.html

.PHONY: generate
generate: $(GEN_ATOMICINT) $(GEN_ATOMICWRAPPER)
	go generate ./...

.PHONY: generatenodirty
generatenodirty:
	@[ -z "$$(git status --porcelain)" ] || ( \
		echo "Working tree is dirty. Commit your changes first."; \
		git status; \
		exit 1 )
	@make generate
	@status=$$(git status --porcelain); \
		[ -z "$$status" ] || ( \
		echo "Working tree is dirty after `make generate`:"; \
		echo "$$status"; \
		echo "Please ensure that the generated code is up-to-date." )

=== debian/changelog ===
docker.io (27.5.1+dfsg1-2) experimental; urgency=medium

  * Fixup engine-ftbfs-mips.patch, Closes: #1118148
  * Install additional go packages

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 16 Oct 2025 08:24:35 -0400

docker.io (27.5.1+dfsg1-1) experimental; urgency=medium

  * builds against the Debian-packaged etcd sources
  * New upstream release, Closes: #1098803
    - Applied a fix for CVE-2024-41110 / GHSA-v23v-6jw2-98fq, which
      impacted setups utilizing authorization plugins (AuthZ) for access
      control

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 14 Oct 2025 06:56:53 -0400

docker.io (26.1.5+dfsg1-10) unstable; urgency=medium

  * Backport a couple patches (FTBFS due to runc upload; Closes: #1115952)
    - https://github.com/moby/moby/pull/48730
      "daemon: use OwnCgroupPath in withCgroups"
    - https://github.com/moby/moby/pull/49562
      "switch to github.com/opencontainers/cgroups"

 -- Tianon Gravi <tianon@debian.org>  Thu, 25 Sep 2025 13:10:41 -0700

=== debian/watch ===
# https://salsa.debian.org/snippets/95
# https://wiki.debian.org/debian/watch
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
compression=xz,\
repack,repacksuffix=+dfsg1,\
dversionmangle=s{[+~]dfsg\d*}{},\
uversionmangle=s{(\d)[\-]?((rc|beta)\d*)$}{$1~$2},\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%,\
searchmode=plain,\
" https://api.github.com/repos/moby/moby/releases?per_page=99 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?(27[\d.]+) debian ./debian/get-orig-source.sh

## docker.io 27.5.1+dfsg2

=== debian/changelog ===
docker.io (27.5.1+dfsg2-1) experimental; urgency=medium

  [ Nicolas Peugnet ]
  * Use distrib version of tonistiigi-vt100
  * Use distrib version of go-viper-mapstructure

  [Reinhard Tartler]
  * Repack tarball

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 18 Oct 2025 08:40:25 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: docker.io
 Section: admin
 Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Arnaud Rebillout <arnaudr@kali.org>
           ,Dmitry Smirnov <onlyjob@debian.org>
@@ -55,6 +55,7 @@
     ,golang-github-docker-go-units-dev (>= 0.4.0~)
     ,golang-github-docker-libkv-dev
     ,golang-github-docker-libtrust-dev
+    ,golang-github-docker-notary-dev (>= 0.7.0+git20240416)
     ,golang-github-felixge-httpsnoop-dev
     ,golang-github-fernet-fernet-go-dev
     ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
@@ -138,7 +139,6 @@
     ,golang-go-zfs-dev
     ,golang-protobuf-extensions-dev
     ,golang-k8s-klog-dev
-    ,golang-k8s-sigs-yaml-dev
     ,gotestsum
     ,libapparmor-dev
     ,libseccomp-dev
@@ -180,14 +180,16 @@
     docker-ce
     ,docker-ce-rootless-extras
 Suggests: docker-doc
+    ,aufs-tools
     ,btrfs-progs
+    ,cgroupfs-mount
     ,debootstrap
     ,e2fsprogs
     ,rinse
     ,rootlesskit
     ,xfsprogs
     ,zfs-fuse | zfsutils-linux
-Static-Built-Using: ${misc:Static-Built-Using}
+Built-Using: ${misc:Built-Using}
 Description: Linux container runtime
  Docker complements kernel namespacing with a high-level API which operates at
  the process level. It runs unix processes with strong guarantees of isolation
@@ -200,14 +202,12 @@
  This package contains the daemon only. For the command-line utility
  "/usr/bin/docker", please install the "docker-cli" package.
  .
- WARNING: Installation starts the daemon immediately and adds iptables rules
- for container networking. These may disrupt existing firewall setups or VM
- networking, potentially breaking connectivity. Test on non-critical systems
- first. To disable: set DOCKER_OPTS="--iptables=false" in /etc/default/docker
- before install. Also, the default configuration will create a "docker0" bridge
- interface for container networking. To configure this behavior, please check
- the documentation on the "--bip" and "-b" command-line arguments in
- dockerd(8).
+ Using docker.io on non-amd64 hosts is not supported at this time. Please be
+ careful when using it on anything besides amd64.
+ .
+ Also, note that kernel version 3.8 or above is required for proper operation of
+ the daemon process, and that any lower versions may have subtle and/or glaring
+ issues.
 
 Package: docker-cli
 Architecture: linux-any
@@ -219,11 +219,11 @@
 ## podman-docker is providing an alternative docker implementation
     ,podman-docker
 # the version of "docker.io" prior to the introduction of the separate "docker-cli" package
-Replaces: docker.io (<< 27.5.1)
-Breaks: docker.io (<< 27.5.1)
+Replaces: docker.io (<< 26.1.4+dfsg1-7~)
+Breaks: docker.io (<< 26.1.4+dfsg1-7~)
 Recommends: docker-buildx
 Suggests: docker-doc
-Static-Built-Using: ${misc:Static-Built-Using}
+Built-Using: ${misc:Built-Using}
 Description: Linux container runtime -- client
  This package contains the "docker" client binary for interacting with a running
  Docker daemon.
@@ -246,6 +246,7 @@
     ,golang-github-docker-go-metrics-dev
     ,golang-github-docker-go-units-dev (>= 0.4.0~)
     ,golang-github-docker-libkv-dev
+    ,golang-github-docker-notary-dev (>= 0.7.0+git20240416)
     ,golang-github-distribution-reference-dev
     ,golang-github-fsnotify-fsnotify-dev
     ,golang-github-fvbommel-sortorder-dev
@@ -284,13 +285,15 @@
     ,golang-github-ishidawataru-sctp-dev
     ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
     ,golang-github-vishvananda-netns-dev
-Breaks:
-    ,crowdsec (<< 1.4.6-10.1)
-    ,docker-compose (<< 2.32)
-    ,golang-github-docker-buildx-dev (<< 0.19)
-    ,golang-github-containers-buildah-dev (<< 1.41.5+ds1-2)
-    ,golang-github-openshift-imagebuilder-dev (<< 1.2.15+ds1-3)
-Conflicts:
-    golang-github-docker-notary-dev
-Replaces:
-    golang-github-docker-notary-dev
+Description: reusable Go packages included with Docker
+ These packages are intentionally developed by upstream in such a way that they
+ are reusable to projects outside Docker and only rely on each other or other
+ external dependencies to be built.
+
+Package: docker-doc
+Provides: docker.io-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: Linux container runtime -- documentation

=== debian/rules ===
--- 
+++ 
@@ -164,7 +164,3 @@
 override_dh_installudev:
 	# use priority z80 to match the upstream priority of 80
 	dh_installudev -v --name=docker --priority=z80
-
-override_dh_gencontrol:
-	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
-	dh_gencontrol

=== debian/watch ===
--- 
+++ 
@@ -6,7 +6,7 @@
 opts="\
 pgpmode=none,\
 compression=xz,\
-repack,repacksuffix=+dfsg1,\
+repack,repacksuffix=+dfsg2,\
 dversionmangle=s{[+~]dfsg\d*}{},\
 uversionmangle=s{(\d)[\-]?((rc|beta)\d*)$}{$1~$2},\
 filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%,\
